; GUI #
; 
;  4kogltutor\bin\sharpe.exe
include win64a.inc
; --------------- 
WINDOWWIDTH  	equ 400
WINDOWHEIGHT	equ 440

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;     ()
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
	invoke glMatrixMode,GL_PROJECTION;     ()
;    , ..    (  glcall ..     8 )
	movq	xmm0,constd90_0
	movq	xmm1,ratio
	movq	xmm2,constd0_1
	movq	xmm3,constd100_0
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0;     
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
;  
	invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke glLoadIdentity
;     (z=-5   =-1,5)
	movd	xmm0,ebx
	movd	xmm1,ebx
	movd	xmm2,const_50_0
	invoke	glTranslatef
        call	draw_triangle
	invoke	glPushMatrix
        invoke  glEnable, GL_LINE_STIPPLE
	invoke  glLineStipple, 1, 0F0F0h
;--------------------------------------------------
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const_20_0
	invoke  glTranslatef;, -20.0, 0.0, 0.0
	call    draw_triangle
	invoke	glPopMatrix
	invoke	glPushMatrix
	invoke	glLineStipple,1,0F00Fh
	movd	xmm2,const1_0
	movd	xmm1,const0_5
	movd	xmm0,const_1_5
	invoke  glScalef;, 1.5, 0.5, 1.0
	call    draw_triangle
	invoke	glPopMatrix
	invoke	glLineStipple,1,8888h
	movd	xmm3,const1_0
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const90_0
	invoke  glRotatef;, 90.0, 0.0, 0.0, 1.0
	call    draw_triangle
        invoke  glDisable, GL_LINE_STIPPLE
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	retn	
WndProc	endp
;----------------------------------------------
draw_triangle proc
	enter	20h,0
	invoke	glBegin,GL_LINE_LOOP
; 1- 
	movd	xmm0,ebx
	movd	xmm1,const25_0
	invoke	glVertex2f;  
; 2- 
	movd	xmm0,const25_0
	movd	xmm1,const_25_0
	invoke	glVertex2f;  
; 3- 
	mov	eax,const_25_0
	movd	xmm0,eax
	movd	xmm1,eax
	invoke	glVertex2f;  
;  
	invoke	glEnd
	leave
	retn
draw_triangle endp
;----------------------------------------------
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "Uncle Remus tales:#40 OpenGL - Model Transformations",0
FileName	db "..\Images\br_Rabbit3.cur",0
ratio	dq	0.90909090909090909090909090909;400/440
const0_5	dd 0.5
const1_0	dd 1.0
const_1_0	dd -1.0
const_1_5	dd -1.5
const_20_0	dd -20.0
const20_0	dd 20.0
const25_0	dd 25.0
const_25_0	dd -25.0
const90_0	dd 90.0
const_50_0	dd -50.0

constd90_0	dq 90.0
constd0_1	dq 0.1
constd100_0	dq 100.0
end